#include <iostream>

#include <Socket.h>
#include <SecureSocket.h>

using namespace std;

status_t Open(const char *address, int port, bool use_ssl)
{
	if (port <= 0)
		port = use_ssl ? 465 : 25;
		
	cout << "***" << endl;
	cout << "Connecting to server: " << address << " port: " << port << " ssl: " << use_ssl << endl;

	BNetworkAddress addr(address);
	if (addr.InitCheck() != B_OK) {
		BString str;
		str.SetToFormat("Invalid network address for SMTP server: %s",
			strerror(addr.InitCheck()));
		cout << str << endl;
		return addr.InitCheck();
	}
		
	if (addr.Port() == 0)
		addr.SetPort(port);

	BSocket *fSocket = nullptr;
	if (use_ssl)
		fSocket = new(std::nothrow) BSecureSocket;
	else
		fSocket = new(std::nothrow) BSocket;
	
	if (!fSocket)
		return B_NO_MEMORY;
	
	if (fSocket->Connect(addr) != B_OK) {
		BString error;
		error << "Could not connect to SMTP server "
			<< address;
		error << ":" << addr.Port();
		cout << error << endl;
		delete fSocket;
		return B_ERROR;
	}

	// BString line;
	// ReceiveResponse(line);

	// char localhost[255];
	// gethostname(localhost, 255);

	// if (localhost[0] == 0)
		// strcpy(localhost, "namethisbebox");

	// char *cmd = new char[::strlen(localhost)+8];
	// if (!esmtp)
		// ::sprintf(cmd,"HELO %s" CRLF, localhost);
	// else
		// ::sprintf(cmd,"EHLO %s" CRLF, localhost);

	// if (SendCommand(cmd) != B_OK) {
		// delete[] cmd;
		// return B_ERROR;
	// }

	// delete[] cmd;

	// Check auth type
	// if (esmtp) {
		// const char *res = fLog.String();
		// char *p;
		// if ((p = ::strstr(res, "250-AUTH")) != NULL
				// || (p = ::strstr(res, "250 AUTH")) != NULL) {
			// if(::strstr(p, "LOGIN"))
				// fAuthType |= LOGIN;
			// if(::strstr(p, "PLAIN"))
				// fAuthType |= PLAIN;
			// if(::strstr(p, "CRAM-MD5"))
				// fAuthType |= CRAM_MD5;
			// if(::strstr(p, "DIGEST-MD5")) {
				// fAuthType |= DIGEST_MD5;
				// fServerName = address;
			// }
		// }
	// }
	cout << endl;
	return B_OK;
}


int
main(int argc, char **argv)
{
	BString name = "smtp.mail.me.com";
	
	status_t status = Open(name.String(), 0, true);
	cout << "Status: " << status << endl;
	status = Open(name.String(), 587, true);
	cout << "Status: " << status << endl;
	status = Open(name.String(), 465, true);
	cout << "Status: " << status << endl;
	status = Open(name.String(), 0, true);
	cout << "Status: " << status << endl;
	
	status = Open(name.String(), 0, false);
	cout << "Status: " << status << endl;
	status = Open(name.String(), 587, false);
	cout << "Status: " << status << endl;
	status = Open(name.String(), 465, false);
	cout << "Status: " << status << endl;
	status = Open(name.String(), 0, false);
	cout << "Status: " << status << endl;
}